#!/usr/bin/env python

import sgmllib, string

# modified from http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/52281

class StrippingParser(sgmllib.SGMLParser):

    # These are the HTML tags that we will leave intact
    valid_tags = ('b', 'a', 'i', 'br', 'p')

    from htmlentitydefs import entitydefs # replace entitydefs from sgmllib
    
    def __init__(self):
        sgmllib.SGMLParser.__init__(self)
        self.result = ""
        self.endTagList = [] 
        
    def handle_data(self, data):
        if data:
            self.result = self.result + data

    def handle_charref(self, name):
        self.result = "%s&#%s;" % (self.result, name)
        
    def handle_entityref(self, name):
        if self.entitydefs.has_key(name): 
            x = ';'
        else:
            # this breaks unstandard entities that end with ';'
            x = ''
        self.result = "%s&%s%s" % (self.result, name, x)
    
    def unknown_starttag(self, tag, attrs):
	if tag in ('p', 'br'):
		self.result = self.result + "\n"
	elif tag == 'li':
		self.result = self.result + "\n* "
	elif tag in ('b', 'i'):
		self.result = self.result + "<%s>" % tag

    def unknown_endtag(self, tag):
        if tag in ('p'): self.result = self.result + "\n" 
	elif tag in ('b', 'i'):
		self.result = self.result + "</%s>" % tag


def strip(s):
    """ Strip illegal HTML tags from string s """
    parser = StrippingParser()
    parser.feed(s)
    parser.close()
    return parser.result


